SUBROUTINE OUTBOTTOMFEM
USE STATE
IMPLICIT NONE
INTEGER I,J
REAL, DIMENSION(:,:), ALLOCATABLE :: NODES
INTEGER, DIMENSION(:,:), ALLOCATABLE :: ELEMENTS
INTEGER, DIMENSION(:,:,:), ALLOCATABLE :: CELLS
INTEGER MAXNODES,MAXEL
PARAMETER (MAXNODES=4*IM*JM , MAXEL = 2*IM*JM)
INTEGER NUMNODES,NUMEL
!
WRITE(81,*)'TITLE = "bottom matrix-fem" '
WRITE(81,*)'VARIABLES = "X" "Y" "H" '
!
ALLOCATE (NODES(4,MAXNODES), ELEMENTS(MAXEL,4) , CELLS(0:IM+1,0:JM+1,4) )
NUMNODES = 0
NUMEL = 0
NODES = 0
ELEMENTS = 0
NODES = 0.
CELLS = 0.
!
!
!  Finally the interior
DO I = 1,IM
  DO J = 1,JM
    IF (FSM(I,J).NE.0.) THEN
        CALL ADD1(MAXNODES,MAXEL,NUMNODES,NUMEL,NODES,ELEMENTS,IM,JM,I,J,H,CELLS)
    ENDIF
  END DO
END DO
DO I = 1,NUMNODES
  NODES(3,I) = NODES(3,I)/NODES(4,I)
END DO
!
WRITE(81,*)'ZONE N=',NUMNODES,',E=',NUMEL,', F=FEPOINT, ET=QUADRILATERAL'
DO I = 1,NUMNODES
  WRITE(81,*)NODES(1,I),NODES(2,I),NODES(3,I)
END DO
WRITE(81,*)
DO I = 1,NUMEL
  WRITE(81,*)ELEMENTS(I,1),ELEMENTS(I,2),ELEMENTS(I,3),ELEMENTS(I,4)
END DO
    


!
DEALLOCATE (NODES,ELEMENTS,CELLS)
!
RETURN 
END
