SUBROUTINE PZLEVEL
!
!  S-points at the depth ZLEVEL
!  to the file with Unit number IUNIT
USE MOD_MAIN
IMPLICIT NONE
!
REAL, DIMENSION(IM,JM,KB) :: UIS,VIS
REAL, DIMENSION(IM,JM) :: UZ,VZ,RHOZ
REAL FRACZ
!
! Average U and V to S-points.
!
UIS = U
VIS = V
DO J = 1,JM-1
  DO I = 1,IM-1
    IF (FSM(I,J).NE.0.) THEN
      DO K = 1,KB-1
        UIS(I,J,K) = 0.5*(U(I,J,K)+U(I+1,J,K))
        VIS(I,J,K) = 0.5*(V(I,J,K)+V(I,J+1,K))
      END DO
    ENDIF
  END DO
END DO
!
ZLEVEL = 2.
!
! Compute S, T, U, V and WR at depth ZLEVEL
!
UZ = SPV
VZ = SPV
RHOZ = SPV
DO J = 1,JM
  DO I = 1,IM
    IF (FSM(I,J).NE.0.) THEN
      IF (ZLEVEL.LE.-(ZZ(1)*D(I,J)+ETA(I,J)) ) THEN
        UZ(I,J) = UIS(I,J,1)
        VZ(I,J) = VIS(I,J,1)
        RHOZ(I,J) = RHO(I,J,1) + RHOAVER 
      ELSEIF (ZLEVEL.GT.H(I,J) ) THEN
        UZ(I,J) = SPV
        VZ(I,J) = SPV
        RHOZ(I,J) = SPV
      ELSEIF (ZLEVEL.GE.-(ZZ(KB-1)*D(I,J)+ETA(I,J)) ) THEN
        UZ(I,J) = UIS(I,J,KB-1)
        VZ(I,J) = VIS(I,J,KB-1)
        RHOZ(I,J) = RHO(I,J,KB-1) + RHOAVER 
!
!  Else we interpolate linearly between the layers.
!
      ELSE
        DO K = 1,KB-2
          IF (ZLEVEL.GT.-(ZZ(K)*D(I,J)+ETA(I,J)) .AND. &
            & ZLEVEL.LE.-(ZZ(K+1)*D(I,J)+ETA(I,J))  ) THEN
            FRACZ = (ZLEVEL+(ZZ(K)*D(I,J)+ETA(I,J))) /  &
                  & ((-ZZ(K+1)+ZZ(K))*D(I,J))
            UZ(I,J) = (1.-FRACZ)*UIS(I,J,K) + FRACZ*UIS(I,J,K+1)
            VZ(I,J) = (1.-FRACZ)*VIS(I,J,K) + FRACZ*VIS(I,J,K+1)
            RHOZ(I,J) = (1.-FRACZ)*RHO(I,J,K) + FRACZ*RHO(I,J,K+1)
            RHOZ(I,J) = RHOZ(I,J) + RHOAVER 
            GO TO 100
          ENDIF
        END DO
100     CONTINUE
      ENDIF
    ENDIF
  END DO
END DO
!
!
U2 = UZ
V2 = VZ
RHO2 = RHOZ
!
!  Then repeat for Z = 5
!
ZLEVEL = 5.
!
! Compute S, T, U, V and WR at depth ZLEVEL
!
UZ = SPV
VZ = SPV
RHOZ = SPV
DO J = 1,JM
  DO I = 1,IM
    IF (FSM(I,J).NE.0.) THEN
      IF (ZLEVEL.LE.-(ZZ(1)*D(I,J)+ETA(I,J)) ) THEN
        UZ(I,J) = UIS(I,J,1)
        VZ(I,J) = VIS(I,J,1)
        RHOZ(I,J) = RHO(I,J,1) + RHOAVER 
      ELSEIF (ZLEVEL.GT.H(I,J) ) THEN
        UZ(I,J) = SPV
        VZ(I,J) = SPV
        RHOZ(I,J) = SPV
      ELSEIF (ZLEVEL.GE.-(ZZ(KB-1)*D(I,J)+ETA(I,J)) ) THEN
        UZ(I,J) = UIS(I,J,KB-1)
        VZ(I,J) = VIS(I,J,KB-1)
        RHOZ(I,J) = RHO(I,J,KB-1) + RHOAVER 
!
!  Else we interpolate linearly between the layers.
!
      ELSE
        DO K = 1,KB-2
          IF (ZLEVEL.GT.-(ZZ(K)*D(I,J)+ETA(I,J)) .AND. &
            & ZLEVEL.LE.-(ZZ(K+1)*D(I,J)+ETA(I,J))  ) THEN
            FRACZ = (ZLEVEL+(ZZ(K)*D(I,J)+ETA(I,J))) /  &
                  & ((-ZZ(K+1)+ZZ(K))*D(I,J))
            UZ(I,J) = (1.-FRACZ)*UIS(I,J,K) + FRACZ*UIS(I,J,K+1)
            VZ(I,J) = (1.-FRACZ)*VIS(I,J,K) + FRACZ*VIS(I,J,K+1)
            RHOZ(I,J) = (1.-FRACZ)*RHO(I,J,K) + FRACZ*RHO(I,J,K+1)
            RHOZ(I,J) = RHOZ(I,J) + RHOAVER
            GO TO 200
          ENDIF
        END DO
200     CONTINUE
      ENDIF
    ENDIF
  END DO
END DO
!
!
U5 = UZ
V5 = VZ
RHO5 = RHOZ
RETURN
END
