SUBROUTINE RIVERS(NDATE)
USE MOD_BOUND
IMPLICIT NONE
!
!     NUMC    : Number of rivers
!
INTEGER NDATE(5)
INTEGER I,K
REAL DEPMIX,DEP
!
!   Define the river runoff parameters in all coastal runoff cells.
!
!   The below values are specified by Trygve Sagberg, Department of Geophysics, University
!   of Bergen, 1999.
!
CODERIVER(1) = 4
TRIVER(1) = 10.
FRIVER(1) = 20.980
SRIVER(1) = 0.
IRIVER(1) = 18
JRIVER(1) = 47

CODERIVER(2) = 3
TRIVER(2) = 10.
FRIVER(2) = 5.6543
SRIVER(2) = 0.
IRIVER(2) = 15
JRIVER(2) = 53

CODERIVER(3) = 4
TRIVER(3) = 10.
FRIVER(3) = 5.0625
SRIVER(3) = 0.
IRIVER(3) = 9
JRIVER(3) = 54

CODERIVER(4) = 1
TRIVER(4) = 10.
FRIVER(4) = .9666
SRIVER(4) = 0.
IRIVER(4) = 7
JRIVER(4) = 43

CODERIVER(5) = 3
TRIVER(5) = 10.
FRIVER(5) = .9722
SRIVER(5) = 0.
IRIVER(5) = 12
JRIVER(5) = 32

CODERIVER(6) = 3
TRIVER(6) = 10.
FRIVER(6) = 2.7898
SRIVER(6) = 0.
IRIVER(6) = 25
JRIVER(6) = 37
!
!
!  And then finally introducing a real flooding Arna-river.
!
CODERIVER(7) = 3
TRIVER(7) = 10.
FRIVER(7) = 50.
SRIVER(7) =  0.
IRIVER(7) = 24
JRIVER(7) = 16
!
!  Setting all the
!  river fluxes to 200. m**3/s (which is more than normal)
!
DO I = 1,7
  FRIVER(I) = 100.
END DO    
!
! The above statements should be executed when testing 
! out the river part of the code for the first time that the
! river cell is an ocean cell and that the flow come in the direction from
! a land cell.
! After this is tested, the statements may be commented away as below.
!
!DO I = 1,NUMC
!  WRITE(*,*)I,IRIVER(I),JRIVER(I),FRIVER(I)
!  WRITE(*,*)H(IRIVER(I),JRIVER(I))
!  WRITE(*,*)H(IRIVER(I)-1,JRIVER(I)),H(IRIVER(I),JRIVER(I)-1)
!  WRITE(*,*)H(IRIVER(I)+1,JRIVER(I)),H(IRIVER(I),JRIVER(I)+1)
!  WRITE(*,*)CODERIVER(I)
!END DO 
!STOP
!
!
!  Define outlet in the upper approx. 5 meters
!
DEPMIX = 5.0
DO I = 1,NUMC
  KRIVER1(I) = 1
  DO K = 1,KB-1
    DEP = -Z(K+1)*H(IRIVER(I),JRIVER(I))
    IF (DEPMIX.LT.DEP) THEN
      KRIVER2(I) = K
      GO TO 105
    ENDIF
  END DO
  KRIVER2(I) = KB-1
105 CONTINUE
END DO

!
!  Compute the fraction of the vertical covered by the river outlet.
!
DO I = 1,NUMC
  DZRIVER(I) = -Z(KRIVER2(I)+1)+Z(KRIVER1(I))
END DO
!
!
RETURN
END
