SUBROUTINE STEPU2D(DTE,AX,C2U)
  USE STATE
  IMPLICIT NONE
  REAL DTE
  REAL AX(IM,JM),C2U(IM,JM),VU2D(IM,JM),CORU(IM,JM)
  INTEGER I,J
!
!  Define V*D in U-points.
!  
!DO J = 2,JM-1
!   DO I = 2,IM
!      VU2D(I,J) = 0.25*(DV(I,J+1)*VA(I,J+1)+DV(I,J)*VA(I,J)+&
!           &  DV(I-1,J+1)*VA(I-1,J+1)+DV(I-1,J)*VA(I-1,J))
!   END DO
!END DO
  VU2D = 0.

!$omp parallel do
  DO J = 2,JM-1
     DO I = 2,IM
        IF (DUM(I,J).GT.0.) THEN
           IF (DVM(I,J+1).GT.0.) THEN
              VU2D(I,J) = VA(I,J+1)*DV(I,J+1)/HVSQR(I,J+1)
           ENDIF
           IF (DVM(I,J).GT.0.) THEN
              VU2D(I,J) = VU2D(I,J) + VA(I,J)*DV(I,J)/HVSQR(I,J)
           ENDIF
           IF (DVM(I-1,J+1).GT.0.) THEN
              VU2D(I,J) = VU2D(I,J) + VA(I-1,J+1)*DV(I-1,J+1)/HVSQR(I-1,J+1)
           ENDIF
           IF (DVM(I-1,J).GT.0.) THEN
              VU2D(I,J) = VU2D(I,J) + VA(I-1,J)*DV(I-1,J)/HVSQR(I-1,J)
           ENDIF
           VU2D(I,J) = 0.25*VU2D(I,J)*HUSQR(I,J)
        ENDIF
     END DO
  END DO
!
! Propagate the solution taking all terms into account.
!
!$omp parallel do firstprivate(dx)
  DO J = 2,JM-1
     DO I = 2,IM
        CORU(I,J) = COR(I,J)*VU2D(I,J) - GRAV*DU(I,J)* &
             &  (ETA(I,J)-ETA(I-1,J))/DX + AX(I,J) + C2U(I,J)        
     END DO
  END DO

!$omp parallel do firstprivate(dte)
  DO J = 2,JM-1
     DO I = 2,IM
        IF (DUM(I,J).NE.0.) THEN
           UA(I,J) = UA(I,J) + DTE*CORU(I,J)/DU(I,J)
        ENDIF
     END DO
  END DO
!
END SUBROUTINE STEPU2D
