SUBROUTINE STEPU3D(UBCLIN,VBCLIN,C3U,AX)
  USE STATE
  IMPLICIT NONE
  REAL UBCLIN(IM,JM,KB),VBCLIN(IM,JM,KB),C3U(IM,JM,KB),AX(IM,JM)
  REAL VU(IM,JM,KB)
  INTEGER I,J,K

!  Propagate the solution in UBCLIN.
!
!Define V*D in U-points.
!
!DO K = 1,KB-1
!  DO J = 2,JM-1
!     DO I = 2,IM
!        VU(I,J,K) = 0.25*(DV(I,J+1)*VBCLIN(I,J+1,K)+DV(I,J)*VBCLIN(I,J,K)+&
!             &  DV(I-1,J+1)*VBCLIN(I-1,J+1,K)+DV(I-1,J)*VBCLIN(I-1,J,K))
!     END DO
!  END DO
!END DO
  VU = 0.
!$OMP PARALLEL DO PRIVATE(I,J,K)
  DO K = 1,KB-1
     DO J = 2,JM-1
        DO I = 2,IM
           IF (DUM(I,J).GT.0.) THEN
              IF (DVM(I,J+1).GT.0.) THEN
                 VU(I,J,K) = VBCLIN(I,J+1,K)*DV(I,J+1)/HVSQR(I,J+1)
              ENDIF
              IF (DVM(I,J).GT.0.) THEN
                 VU(I,J,K) = VU(I,J,K) + VBCLIN(I,J,K)*DV(I,J)/HVSQR(I,J)
              ENDIF
              IF (DVM(I-1,J+1).GT.0.) THEN
                 VU(I,J,K) = VU(I,J,K) + VBCLIN(I-1,J+1,K)*DV(I-1,J+1)/HVSQR(I-1,J+1)
              ENDIF
              IF (DVM(I-1,J).GT.0.) THEN
                 VU(I,J,K) = VU(I,J,K) + VBCLIN(I-1,J,K)*DV(I-1,J)/HVSQR(I-1,J)
              ENDIF
              VU(I,J,K) = 0.25*VU(I,J,K)*HUSQR(I,J)
           ENDIF
        END DO
     END DO
  END DO
!
!$OMP PARALLEL DO PRIVATE(I,J,K)
  DO K = 1,KB-1
     DO J = 2,JM-1
        DO I = 2,IM
           DELTAU(I,J,K) = COR(I,J)*VU(I,J,K) + DELTAU(I,J,K) - AX(I,J) 
           DELTAU(I,J,K) = DELTAU(I,J,K) + C3U(I,J,K)
        END DO
     END DO
  END DO

!$OMP PARALLEL DO PRIVATE(I,J,K)
  DO J = 2,JM-1
     DO I = 2,IM
        IF (DUM(I,J).NE.0.) THEN
           DO K = 1,KB-1
              UBCLIN(I,J,K) = UBCLIN(I,J,K) + DT*DELTAU(I,J,K)/DU(I,J)
              U(I,J,K) = UBCLIN(I,J,K) + UA(I,J)              
           END DO
        ENDIF
     END DO
  END DO

  RETURN
END SUBROUTINE STEPU3D
   
