SUBROUTINE TIDEFRS(IS)
USE MOD_MAIN
IMPLICIT NONE
INTEGER IS
!
REAL TIMESEC
!
!  TIDEFRS updates the fields ETATFRS,UATFRS,VATFRS,UTFRS,VTFRS
!  as a function of time and the amplitudes and phases of the
!  tidal components
!
TIMESEC = DT*(ISTEP-1) + DT*IS/N2D
ETATFRS = 0.
I = 1
J = 1
DO K = 1,KCON
      ETATFRS(I,J) =  ETATFRS(I,J) + ETATAMP(I,J,K)*COS(FREQ(K)*TIMESEC-ETATPHA(I,J,K))
END DO
!
!  Then define ETATFRS through the FRS-zones such that d(ETA)/dX is
!  correct assuming that the speed of the wave is SQRT(GRAV*H).
!
DO I = 1,LB
  DO J = 13,14
    ETATFRS(I,J) = ETATFRS(1,1) 
  END DO
END DO
DO I = 15,18
  DO J = 1,LB
    ETATFRS(I,J) = ETATFRS(1,1) 
  END DO
END DO
!
UATFRS = 0.
VATFRS = 0.
!
UTFRS = 0.
VTFRS = 0.
!
RETURN
END
