SUBROUTINE UPDATEDD
USE STATE
IMPLICIT NONE
INTEGER I,J,K
!
! UPDATEDD updates the Dynamic Depth fields
! D,DU,DV,DDZ,DUDZ and DVDZ
! after ETA is updated in each time step.
!
D(1:IM,1:JM) = FSM(1:IM,1:JM)*(H(1:IM,1:JM)+ETA(1:IM,1:JM))
DU(1,1:JM) = DUM(1,1:JM)*(HU(1,1:JM)+ETA(1,1:JM))
DU(2:IM,1:JM) = DUM(2:IM,1:JM)*(HU(2:IM,1:JM)+0.5* &
     & (ETA(1:IM-1,1:JM)+ETA(2:IM,1:JM)))
DV(1:IM,1) = DVM(1:IM,1)*(HV(1:IM,1)+ETA(1:IM,1))
DV(1:IM,2:JM) = DVM(1:IM,2:JM)*(HV(1:IM,2:JM)+0.5* &
     & (ETA(1:IM,1:JM-1)+ETA(1:IM,2:JM)))
DO K = 1,KB-1
  DO I = 1,IM
    DO J = 1,JM
      DDZ(I,J,K) = DZ(K)*D(I,J)
      DUDZ(I,J,K) = DZ(K)*DU(I,J)
      DVDZ(I,J,K) = DZ(K)*DV(I,J)
    END DO
  END DO
END DO
RETURN
END
