SUBROUTINE WINDFORCING
!
!  WINDFORCING estimates 
!  the wind stresses WUSURF and WVSURF
!  from windspeeds 10m above the sea surface
!
!  PATM may also be redefined in WINDFORCING
!
USE MOD_MAIN
IMPLICIT NONE
REAL TIMEHOUR,ROAD0,WS,FACT,CDRAG
!
!  Spin up a wind with constant direction as a function of time.
!
TIMEHOUR = DT*ISTEP/3600.
IF (TIMEHOUR .LT. 12.) THEN
   WSPEEDU = 5.*TIMEHOUR/12.
   WSPEEDV = 0.
ELSE
   WSPEEDU = 5.
   WSPEEDV = 0.
END IF
!
!  Compute WUSURF and WVSURF from the wind speeds.
!
ROAD0=ROAIR/RHO0
!
DO I=1,IM
  DO J=1,JM
     WS=SQRT(WSPEEDU(I,J)*WSPEEDU(I,J)+WSPEEDV(I,J)*WSPEEDV(I,J))
     FACT=1.2
     IF(WS.GE.11.) FACT=0.49 +0.065*WS
     CDRAG=1.0E-3*FACT
     WUSURF(I,J)=ROAD0*CDRAG*WS*WSPEEDU(I,J)
     WVSURF(I,J)=ROAD0*CDRAG*WS*WSPEEDV(I,J)
  END DO
END DO
WRITE(*,*)'WIND',WSPEEDU(20,20),WUSURF(20,20)
!
!  Define the atmospheric pressure
!
PATM = PMEAN
!
RETURN
END
